<?PHP

set_exception_handler('exception_panic');


function exception_panic($exception){
  header("HTTP/1.1 500 System Error");
  panic("System Error", $exception->getMessage(), "", $exception->getTrace());
}

function panic($area, $error, $details, $backtrace = false){

echo <<<EOW
<style type="text/css">
#panic {
	border: 1px solid black;
	width: 500px;
	background: url("http://imperial.istic.net/static/icons/dialog-error.png") no-repeat 10px center;
	margin-bottom: 20px;
	font-family: sans-serif;
	position: relitive;
}

#panic h2 {
	margin: 0;
	border-bottom: 1px solid black;
	font-size: 14pt;
	color: white;
	background: #00007F;
}

#panic p {
	padding-left: 75px;
}
</style>
EOW;

  if(!$backtrace){
  	$backtrace = debug_backtrace();
  	#array_shift($backtraceR);
  }
  
  
	$output = "<table>";

	foreach($backtrace as $trace){

		if (isset($trace['class'])){
			$coords = basename($trace['file']).":".$trace['line']." ".$trace['class']."->".$trace['function']."()";
		} else {
			$coords = basename($trace['file']).":".$trace['line']." ".$trace['function']."()";
		}

		$output .= "<tr> <td>".$trace['function']."</td>"
			."<td>".$coords."</td>"
			#."<td>".print_r($trace,1)."</td>"
			."</tr>";
	}
	$output .= "</table>";

	echo "<div id=\"panic\"><h2>$area</h2><p>Sorry, something's gone wrong somewhere. Since this site is in Debug mode, you can see exactly where: </p><p><b>$error</b><br/>$details</p>$output</div>";die();
}

?>